Index: uspace/lib/c/generic/task.c
===================================================================
--- uspace/lib/c/generic/task.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/task.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -69,11 +69,11 @@
  *             program.
  *
- * @return Zero on success or an error code.
- */
-errno_t task_set_name(const char *name)
+ * @return Zero on success or negative error code.
+ */
+int task_set_name(const char *name)
 {
 	assert(name);
 	
-	return (errno_t) __SYSCALL2(SYS_TASK_SET_NAME, (sysarg_t) name, str_size(name));
+	return __SYSCALL2(SYS_TASK_SET_NAME, (sysarg_t) name, str_size(name));
 }
 
@@ -82,10 +82,10 @@
  * @param task_id ID of task to kill.
  *
- * @return Zero on success or an error code.
- */
-
-errno_t task_kill(task_id_t task_id)
-{
-	return (errno_t) __SYSCALL1(SYS_TASK_KILL, (sysarg_t) &task_id);
+ * @return Zero on success or negative error code.
+ */
+
+int task_kill(task_id_t task_id)
+{
+	return (int) __SYSCALL1(SYS_TASK_KILL, (sysarg_t) &task_id);
 }
 
@@ -101,8 +101,8 @@
  * @param argv Command-line arguments.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t task_spawnv(task_id_t *id, task_wait_t *wait, const char *path,
+ * @return Zero on success or negative error code.
+ *
+ */
+int task_spawnv(task_id_t *id, task_wait_t *wait, const char *path,
     const char *const args[])
 {
@@ -143,8 +143,8 @@
  * @param std_err File to use as stderr.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t task_spawnvf(task_id_t *id, task_wait_t *wait, const char *path,
+ * @return Zero on success or negative error code.
+ *
+ */
+int task_spawnvf(task_id_t *id, task_wait_t *wait, const char *path,
     const char *const args[], int fd_stdin, int fd_stdout, int fd_stderr)
 {
@@ -158,5 +158,5 @@
 	/* Get task ID. */
 	task_id_t task_id;
-	errno_t rc = loader_get_task_id(ldr, &task_id);
+	int rc = loader_get_task_id(ldr, &task_id);
 	if (rc != EOK)
 		goto error;
@@ -249,8 +249,8 @@
  * @param ap   Command-line arguments.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t task_spawn(task_id_t *task_id, task_wait_t *wait, const char *path,
+ * @return Zero on success or negative error code.
+ *
+ */
+int task_spawn(task_id_t *task_id, task_wait_t *wait, const char *path,
     int cnt, va_list ap)
 {
@@ -269,5 +269,5 @@
 	
 	/* Spawn task. */
-	errno_t rc = task_spawnv(task_id, wait, path, arglist);
+	int rc = task_spawnv(task_id, wait, path, arglist);
 	
 	/* Free argument list. */
@@ -287,8 +287,8 @@
  * @param ...  Command-line arguments.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t task_spawnl(task_id_t *task_id, task_wait_t *wait, const char *path, ...)
+ * @return Zero on success or negative error code.
+ *
+ */
+int task_spawnl(task_id_t *task_id, task_wait_t *wait, const char *path, ...)
 {
 	/* Count the number of arguments. */
@@ -306,5 +306,5 @@
 	
 	va_start(ap, path);
-	errno_t rc = task_spawn(task_id, wait, path, cnt, ap);
+	int rc = task_spawn(task_id, wait, path, cnt, ap);
 	va_end(ap);
 	
@@ -323,5 +323,5 @@
  * @return EOK on success, else error code.
  */
-errno_t task_setup_wait(task_id_t id, task_wait_t *wait)
+int task_setup_wait(task_id_t id, task_wait_t *wait)
 {
 	async_sess_t *sess_ns = ns_session_get();
@@ -364,10 +364,10 @@
  * @return EOK on success, else error code.
  */
-errno_t task_wait(task_wait_t *wait, task_exit_t *texit, int *retval)
+int task_wait(task_wait_t *wait, task_exit_t *texit, int *retval)
 {
 	assert(texit);
 	assert(retval);
 
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(wait->aid, &rc);
 
@@ -394,8 +394,8 @@
  * @return EOK on success, else error code.
  */
-errno_t task_wait_task_id(task_id_t id, task_exit_t *texit, int *retval)
+int task_wait_task_id(task_id_t id, task_exit_t *texit, int *retval)
 {
 	task_wait_t wait;
-	errno_t rc = task_setup_wait(id, &wait);
+	int rc = task_setup_wait(id, &wait);
 	if (rc != EOK)
 		return rc;
@@ -404,5 +404,5 @@
 }
 
-errno_t task_retval(int val)
+int task_retval(int val)
 {
 	async_sess_t *sess_ns = ns_session_get();
@@ -411,5 +411,5 @@
 
 	async_exch_t *exch = async_exchange_begin(sess_ns);
-	errno_t rc = (errno_t) async_req_1_0(exch, NS_RETVAL, val);
+	int rc = (int) async_req_1_0(exch, NS_RETVAL, val);
 	async_exchange_end(exch);
 	
Index: uspace/lib/c/generic/thread.c
===================================================================
--- uspace/lib/c/generic/thread.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/thread.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -105,5 +105,5 @@
  * @return Zero on success or a code from @ref errno.h on failure.
  */
-errno_t thread_create(void (* function)(void *), void *arg, const char *name,
+int thread_create(void (* function)(void *), void *arg, const char *name,
     thread_id_t *tid)
 {
@@ -132,5 +132,5 @@
 	uarg->uspace_uarg = uarg;
 	
-	errno_t rc = (errno_t) __SYSCALL4(SYS_THREAD_CREATE, (sysarg_t) uarg,
+	int rc = __SYSCALL4(SYS_THREAD_CREATE, (sysarg_t) uarg,
 	    (sysarg_t) name, (sysarg_t) str_size(name), (sysarg_t) tid);
 	
@@ -178,5 +178,5 @@
  * @return Thread exit status.
  */
-errno_t thread_join(thread_id_t thread)
+int thread_join(thread_id_t thread)
 {
 	return 0;
Index: uspace/lib/c/generic/time.c
===================================================================
--- uspace/lib/c/generic/time.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/time.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -585,5 +585,5 @@
 	if (clock_conn == NULL) {
 		category_id_t cat_id;
-		errno_t rc = loc_category_get_id("clock", &cat_id, IPC_FLAG_BLOCKING);
+		int rc = loc_category_get_id("clock", &cat_id, IPC_FLAG_BLOCKING);
 		if (rc != EOK)
 			goto fallback;
@@ -617,5 +617,5 @@
 	
 	struct tm time;
-	errno_t rc = clock_dev_time_get(clock_conn, &time);
+	int rc = clock_dev_time_get(clock_conn, &time);
 	if (rc != EOK)
 		goto fallback;
@@ -634,5 +634,5 @@
 	if (ktime == NULL) {
 		uintptr_t faddr;
-		errno_t rc = sysinfo_get_value("clock.faddr", &faddr);
+		int rc = sysinfo_get_value("clock.faddr", &faddr);
 		if (rc != EOK) {
 			errno = rc;
@@ -954,8 +954,8 @@
  * @param result Structure to store the result to
  *
- * @return EOK or an error code
- *
- */
-errno_t time_utc2tm(const time_t time, struct tm *restrict result)
+ * @return EOK or a negative error code
+ *
+ */
+int time_utc2tm(const time_t time, struct tm *restrict result)
 {
 	assert(result != NULL);
@@ -984,11 +984,11 @@
  *             ASCTIME_BUF_LEN bytes long.
  *
- * @return EOK or an error code.
- *
- */
-errno_t time_utc2str(const time_t time, char *restrict buf)
+ * @return EOK or a negative error code.
+ *
+ */
+int time_utc2str(const time_t time, char *restrict buf)
 {
 	struct tm tm;
-	errno_t ret = time_utc2tm(time, &tm);
+	int ret = time_utc2tm(time, &tm);
 	if (ret != EOK)
 		return ret;
@@ -1036,8 +1036,8 @@
  * @param result Structure to store the result to.
  *
- * @return EOK on success or an error code.
- *
- */
-errno_t time_tv2tm(const struct timeval *tv, struct tm *restrict result)
+ * @return EOK on success or a negative error code.
+ *
+ */
+int time_tv2tm(const struct timeval *tv, struct tm *restrict result)
 {
 	// TODO: Deal with timezones.
@@ -1066,8 +1066,8 @@
  * @param result Structure to store the result to.
  *
- * @return EOK on success or an error code.
- *
- */
-errno_t time_local2tm(const time_t time, struct tm *restrict result)
+ * @return EOK on success or a negative error code.
+ *
+ */
+int time_local2tm(const time_t time, struct tm *restrict result)
 {
 	struct timeval tv = {
@@ -1088,11 +1088,11 @@
  *              ASCTIME_BUF_LEN bytes long.
  *
- * @return EOK on success or an error code.
- *
- */
-errno_t time_local2str(const time_t time, char *buf)
+ * @return EOK on success or a negative error code.
+ *
+ */
+int time_local2str(const time_t time, char *buf)
 {
 	struct tm loctime;
-	errno_t ret = time_local2tm(time, &loctime);
+	int ret = time_local2tm(time, &loctime);
 	if (ret != EOK)
 		return ret;
Index: uspace/lib/c/generic/udebug.c
===================================================================
--- uspace/lib/c/generic/udebug.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/udebug.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,5 @@
 #include <async.h>
 
-errno_t udebug_begin(async_sess_t *sess)
+int udebug_begin(async_sess_t *sess)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -45,5 +45,5 @@
 }
 
-errno_t udebug_end(async_sess_t *sess)
+int udebug_end(async_sess_t *sess)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -51,5 +51,5 @@
 }
 
-errno_t udebug_set_evmask(async_sess_t *sess, udebug_evmask_t mask)
+int udebug_set_evmask(async_sess_t *sess, udebug_evmask_t mask)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -57,5 +57,5 @@
 }
 
-errno_t udebug_thread_read(async_sess_t *sess, void *buffer, size_t n,
+int udebug_thread_read(async_sess_t *sess, void *buffer, size_t n,
     size_t *copied, size_t *needed)
 {
@@ -63,5 +63,5 @@
 	
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t rc = async_req_3_3(exch, IPC_M_DEBUG, UDEBUG_M_THREAD_READ,
+	int rc = async_req_3_3(exch, IPC_M_DEBUG, UDEBUG_M_THREAD_READ,
 	    (sysarg_t) buffer, n, NULL, &a_copied, &a_needed);
 	
@@ -72,5 +72,5 @@
 }
 
-errno_t udebug_name_read(async_sess_t *sess, void *buffer, size_t n,
+int udebug_name_read(async_sess_t *sess, void *buffer, size_t n,
     size_t *copied, size_t *needed)
 {
@@ -78,5 +78,5 @@
 	
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t rc = async_req_3_3(exch, IPC_M_DEBUG, UDEBUG_M_NAME_READ,
+	int rc = async_req_3_3(exch, IPC_M_DEBUG, UDEBUG_M_NAME_READ,
 	    (sysarg_t) buffer, n, NULL, &a_copied, &a_needed);
 	
@@ -87,5 +87,5 @@
 }
 
-errno_t udebug_areas_read(async_sess_t *sess, void *buffer, size_t n,
+int udebug_areas_read(async_sess_t *sess, void *buffer, size_t n,
     size_t *copied, size_t *needed)
 {
@@ -93,5 +93,5 @@
 	
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t rc = async_req_3_3(exch, IPC_M_DEBUG, UDEBUG_M_AREAS_READ,
+	int rc = async_req_3_3(exch, IPC_M_DEBUG, UDEBUG_M_AREAS_READ,
 	    (sysarg_t) buffer, n, NULL, &a_copied, &a_needed);
 	
@@ -102,5 +102,5 @@
 }
 
-errno_t udebug_mem_read(async_sess_t *sess, void *buffer, uintptr_t addr, size_t n)
+int udebug_mem_read(async_sess_t *sess, void *buffer, uintptr_t addr, size_t n)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -109,5 +109,5 @@
 }
 
-errno_t udebug_args_read(async_sess_t *sess, thash_t tid, sysarg_t *buffer)
+int udebug_args_read(async_sess_t *sess, thash_t tid, sysarg_t *buffer)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -116,5 +116,5 @@
 }
 
-errno_t udebug_regs_read(async_sess_t *sess, thash_t tid, void *buffer)
+int udebug_regs_read(async_sess_t *sess, thash_t tid, void *buffer)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -123,5 +123,5 @@
 }
 
-errno_t udebug_go(async_sess_t *sess, thash_t tid, udebug_event_t *ev_type,
+int udebug_go(async_sess_t *sess, thash_t tid, udebug_event_t *ev_type,
     sysarg_t *val0, sysarg_t *val1)
 {
@@ -129,5 +129,5 @@
 	
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t rc = async_req_2_3(exch, IPC_M_DEBUG, UDEBUG_M_GO,
+	int rc = async_req_2_3(exch, IPC_M_DEBUG, UDEBUG_M_GO,
 	    tid, &a_ev_type, val0, val1);
 	
@@ -136,5 +136,5 @@
 }
 
-errno_t udebug_stop(async_sess_t *sess, thash_t tid)
+int udebug_stop(async_sess_t *sess, thash_t tid)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
Index: uspace/lib/c/generic/uuid.c
===================================================================
--- uspace/lib/c/generic/uuid.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/uuid.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,7 +43,7 @@
  *
  * @param uuid Place to store generated UUID
- * @return EOK on success or an error code
+ * @return EOK on success or negative error code
  */
-errno_t uuid_generate(uuid_t *uuid)
+int uuid_generate(uuid_t *uuid)
 {
 	int i;
@@ -52,8 +52,8 @@
 	/* XXX This is a rather poor way of generating random numbers */
 	gettimeofday(&tv, NULL);
-	srand(tv.tv_sec ^ tv.tv_usec);
+	srandom(tv.tv_sec ^ tv.tv_usec);
 
 	for (i = 0; i < uuid_bytes; i++)
-		uuid->b[i] = rand();
+		uuid->b[i] = random();
 
 	/* Version 4 UUID from random or pseudo-random numbers */
@@ -100,9 +100,9 @@
  * @param endptr Place to store pointer to end of UUID or @c NULL
  *
- * @return EOK on success or an error code
+ * @return EOK on success or negative error code
  */
-errno_t uuid_parse(const char *str, uuid_t *uuid, const char **endptr)
+int uuid_parse(const char *str, uuid_t *uuid, const char **endptr)
 {
-	errno_t rc;
+	int rc;
 	const char *eptr;
 	uint32_t time_low;
@@ -167,5 +167,5 @@
  * @return EOK on success, ENOMEM if out of memory
  */
-errno_t uuid_format(uuid_t *uuid, char **rstr)
+int uuid_format(uuid_t *uuid, char **rstr)
 {
 	return ENOTSUP;
Index: uspace/lib/c/generic/vbd.c
===================================================================
--- uspace/lib/c/generic/vbd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/vbd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,12 +44,12 @@
 #include <vbd.h>
 
-static errno_t vbd_get_ids_internal(vbd_t *, sysarg_t, sysarg_t, sysarg_t **,
+static int vbd_get_ids_internal(vbd_t *, sysarg_t, sysarg_t, sysarg_t **,
     size_t *);
 
-errno_t vbd_create(vbd_t **rvbd)
+int vbd_create(vbd_t **rvbd)
 {
 	vbd_t *vbd;
 	service_id_t vbd_svcid;
-	errno_t rc;
+	int rc;
 
 	vbd = calloc(1, sizeof(vbd_t));
@@ -95,7 +95,7 @@
  * @param count Place to store length of array (number of entries)
  *
- * @return EOK on success or an error code
- */
-errno_t vbd_get_disks(vbd_t *vbd, service_id_t **data, size_t *count)
+ * @return EOK on success or negative error code
+ */
+int vbd_get_disks(vbd_t *vbd, service_id_t **data, size_t *count)
 {
 	return vbd_get_ids_internal(vbd, VBD_GET_DISKS, 0, data, count);
@@ -103,31 +103,31 @@
 
 /** Get disk information. */
-errno_t vbd_disk_info(vbd_t *vbd, service_id_t sid, vbd_disk_info_t *vinfo)
-{
-	async_exch_t *exch;
-	errno_t retval;
+int vbd_disk_info(vbd_t *vbd, service_id_t sid, vbd_disk_info_t *vinfo)
+{
+	async_exch_t *exch;
+	sysarg_t retval;
 	ipc_call_t answer;
 
 	exch = async_exchange_begin(vbd->sess);
 	aid_t req = async_send_1(exch, VBD_DISK_INFO, sid, &answer);
-	errno_t rc = async_data_read_start(exch, vinfo, sizeof(vbd_disk_info_t));
-	async_exchange_end(exch);
-
-	if (rc != EOK) {
-		async_forget(req);
-		return EIO;
-	}
-
-	async_wait_for(req, &retval);
-	if (retval != EOK)
-		return EIO;
-
-	return EOK;
-}
-
-errno_t vbd_label_create(vbd_t *vbd, service_id_t sid, label_type_t ltype)
-{
-	async_exch_t *exch;
-	errno_t retval;
+	int rc = async_data_read_start(exch, vinfo, sizeof(vbd_disk_info_t));
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		return EIO;
+	}
+
+	async_wait_for(req, &retval);
+	if (retval != EOK)
+		return EIO;
+
+	return EOK;
+}
+
+int vbd_label_create(vbd_t *vbd, service_id_t sid, label_type_t ltype)
+{
+	async_exch_t *exch;
+	int retval;
 
 	exch = async_exchange_begin(vbd->sess);
@@ -141,8 +141,8 @@
 }
 
-errno_t vbd_label_delete(vbd_t *vbd, service_id_t sid)
-{
-	async_exch_t *exch;
-	errno_t retval;
+int vbd_label_delete(vbd_t *vbd, service_id_t sid)
+{
+	async_exch_t *exch;
+	int retval;
 
 	exch = async_exchange_begin(vbd->sess);
@@ -165,7 +165,7 @@
  * @param act_size Place to store actual size of complete data.
  *
- * @return EOK on success or an error code.
- */
-static errno_t vbd_get_ids_once(vbd_t *vbd, sysarg_t method, sysarg_t arg1,
+ * @return EOK on success or negative error code.
+ */
+static int vbd_get_ids_once(vbd_t *vbd, sysarg_t method, sysarg_t arg1,
     sysarg_t *id_buf, size_t buf_size, size_t *act_size)
 {
@@ -174,5 +174,5 @@
 	ipc_call_t answer;
 	aid_t req = async_send_1(exch, method, arg1, &answer);
-	errno_t rc = async_data_read_start(exch, id_buf, buf_size);
+	int rc = async_data_read_start(exch, id_buf, buf_size);
 
 	async_exchange_end(exch);
@@ -183,5 +183,5 @@
 	}
 
-	errno_t retval;
+	sysarg_t retval;
 	async_wait_for(req, &retval);
 
@@ -203,7 +203,7 @@
  * @param data   Place to store pointer to array of IDs
  * @param count  Place to store number of IDs
- * @return       EOK on success or an error code
- */
-static errno_t vbd_get_ids_internal(vbd_t *vbd, sysarg_t method, sysarg_t arg1,
+ * @return       EOK on success or negative error code
+ */
+static int vbd_get_ids_internal(vbd_t *vbd, sysarg_t method, sysarg_t arg1,
     sysarg_t **data, size_t *count)
 {
@@ -212,5 +212,5 @@
 
 	size_t act_size = 0;
-	errno_t rc = vbd_get_ids_once(vbd, method, arg1, NULL, 0, &act_size);
+	int rc = vbd_get_ids_once(vbd, method, arg1, NULL, 0, &act_size);
 	if (rc != EOK)
 		return rc;
@@ -247,7 +247,7 @@
  * @param count Place to store length of array (number of entries)
  *
- * @return EOK on success or an error code
- */
-errno_t vbd_label_get_parts(vbd_t *vbd, service_id_t disk,
+ * @return EOK on success or negative error code
+ */
+int vbd_label_get_parts(vbd_t *vbd, service_id_t disk,
     service_id_t **data, size_t *count)
 {
@@ -256,37 +256,37 @@
 }
 
-errno_t vbd_part_get_info(vbd_t *vbd, vbd_part_id_t part, vbd_part_info_t *pinfo)
-{
-	async_exch_t *exch;
-	errno_t retval;
+int vbd_part_get_info(vbd_t *vbd, vbd_part_id_t part, vbd_part_info_t *pinfo)
+{
+	async_exch_t *exch;
+	sysarg_t retval;
 	ipc_call_t answer;
 
 	exch = async_exchange_begin(vbd->sess);
 	aid_t req = async_send_1(exch, VBD_PART_GET_INFO, part, &answer);
-	errno_t rc = async_data_read_start(exch, pinfo, sizeof(vbd_part_info_t));
-	async_exchange_end(exch);
-
-	if (rc != EOK) {
-		async_forget(req);
-		return EIO;
-	}
-
-	async_wait_for(req, &retval);
-	if (retval != EOK)
-		return EIO;
-
-	return EOK;
-}
-
-errno_t vbd_part_create(vbd_t *vbd, service_id_t disk, vbd_part_spec_t *pspec,
+	int rc = async_data_read_start(exch, pinfo, sizeof(vbd_part_info_t));
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		return EIO;
+	}
+
+	async_wait_for(req, &retval);
+	if (retval != EOK)
+		return EIO;
+
+	return EOK;
+}
+
+int vbd_part_create(vbd_t *vbd, service_id_t disk, vbd_part_spec_t *pspec,
     vbd_part_id_t *rpart)
 {
 	async_exch_t *exch;
-	errno_t retval;
+	sysarg_t retval;
 	ipc_call_t answer;
 
 	exch = async_exchange_begin(vbd->sess);
 	aid_t req = async_send_1(exch, VBD_PART_CREATE, disk, &answer);
-	errno_t rc = async_data_write_start(exch, pspec, sizeof(vbd_part_spec_t));
+	int rc = async_data_write_start(exch, pspec, sizeof(vbd_part_spec_t));
 	async_exchange_end(exch);
 
@@ -305,8 +305,8 @@
 }
 
-errno_t vbd_part_delete(vbd_t *vbd, vbd_part_id_t part)
-{
-	async_exch_t *exch;
-	errno_t retval;
+int vbd_part_delete(vbd_t *vbd, vbd_part_id_t part)
+{
+	async_exch_t *exch;
+	int retval;
 
 	exch = async_exchange_begin(vbd->sess);
@@ -332,16 +332,16 @@
  * @param ptype Place to store suggested partition type
  *
- * @return EOK on success or an error code
- */
-errno_t vbd_suggest_ptype(vbd_t *vbd, service_id_t disk, label_pcnt_t pcnt,
+ * @return EOK on success or negative error code
+ */
+int vbd_suggest_ptype(vbd_t *vbd, service_id_t disk, label_pcnt_t pcnt,
     label_ptype_t *ptype)
 {
 	async_exch_t *exch;
-	errno_t retval;
+	sysarg_t retval;
 	ipc_call_t answer;
 
 	exch = async_exchange_begin(vbd->sess);
 	aid_t req = async_send_2(exch, VBD_SUGGEST_PTYPE, disk, pcnt, &answer);
-	errno_t rc = async_data_read_start(exch, ptype, sizeof(label_ptype_t));
+	int rc = async_data_read_start(exch, ptype, sizeof(label_ptype_t));
 	async_exchange_end(exch);
 
Index: uspace/lib/c/generic/vfs/inbox.c
===================================================================
--- uspace/lib/c/generic/vfs/inbox.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/vfs/inbox.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -120,5 +120,5 @@
  *
  * @param name Name of the entry.
- * @return Requested file or -1 if not set.
+ * @return Requested file or ENOENT if not set.
  */
 int inbox_get(const char *name)
@@ -130,9 +130,9 @@
 			return e->file;
 		case 1:
-			return -1;
+			return ENOENT;
 		} 
 	}
 
-	return -1;
+	return ENOENT;
 }
 
Index: uspace/lib/c/generic/vfs/mtab.c
===================================================================
--- uspace/lib/c/generic/vfs/mtab.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/vfs/mtab.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,7 +40,6 @@
 #include <errno.h>
 #include <assert.h>
-#include <str.h>
 
-static void process_mp(const char *path, vfs_stat_t *stat, list_t *mtab_list)
+static void process_mp(const char *path, struct stat *stat, list_t *mtab_list)
 {
 	mtab_ent_t *ent;
@@ -54,5 +53,5 @@
 	ent->service_id = stat->service_id;
 
-	vfs_statfs_t stfs;
+	struct statfs stfs;
 	if (vfs_statfs_path(path, &stfs) == EOK)
 		str_cpy(ent->fs_name, sizeof(ent->fs_name), stfs.fs_name);
@@ -63,5 +62,5 @@
 }
 
-static errno_t vfs_get_mtab_visit(const char *path, list_t *mtab_list,
+static int vfs_get_mtab_visit(const char *path, list_t *mtab_list,
     fs_handle_t fs_handle, service_id_t service_id)
 {
@@ -75,12 +74,11 @@
 	while ((dirent = readdir(dir)) != NULL) {
 		char *child;
-		vfs_stat_t st;
-		errno_t rc;
-		int ret;
+		struct stat st;
+		int rc;
 
-		ret = asprintf(&child, "%s/%s", path, dirent->d_name);
-		if (ret < 0) {
+		rc = asprintf(&child, "%s/%s", path, dirent->d_name);
+		if (rc < 0) {
 			closedir(dir);
-			return ENOMEM;
+			return rc;
 		}
 
@@ -96,5 +94,5 @@
 
 		rc = vfs_stat_path(child, &st);
-		if (rc != EOK) {
+		if (rc != 0) {
 			free(child);
 			closedir(dir);
@@ -121,10 +119,10 @@
 }
 
-errno_t vfs_get_mtab_list(list_t *mtab_list)
+int vfs_get_mtab_list(list_t *mtab_list)
 {
-	vfs_stat_t st;
+	struct stat st;
 
-	errno_t rc = vfs_stat_path("/", &st);
-	if (rc != EOK)
+	int rc = vfs_stat_path("/", &st);
+	if (rc != 0)
 		return rc;
 
